#include-once
#AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6 -w- 7
;~ #AutoIt3Wrapper_Au3Check_Parameters=-q -d -w 1 -w 2 -w 3 -w- 4 -w 5 -w 6 -w- 7
#Tidy_Parameters=/sort_funcs /reel

#Region DPViewer.au3 - Include
#include <MsgBoxConstants.au3>
#include <FileConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <String.au3>
#include <File.au3>
#include <WinAPIFiles.au3>
#include <Color.au3>
#EndRegion QuickPDF Include

#Region DPViewer.au3 - Header
; #INDEX# =======================================================================================================================
; Title .........: UDF for "Debenu PDF Viewer SDK"
; AutoIt Version : 3.3.10.2++
; Language ......: English
; Description ...: A collection of functions for Debenu PDF Viewer SDK
; Author(s) .....: mLipok
; Modified ......:
; ===============================================================================================================================
#cs
	Title:   UDF for "Debenu PDF Viewer SDK"
	Filename:  DPViewer.au3
	Description: A collection of functions for Debenu PDF Viewer SDK
	Author:   mLipok
	Modified:
	Last Update: 2015/04/28
	Requirements:
	AutoIt 3.3.10.2 or higher

	Debenu PDF Viewer SDK
	http://www.debenu.com/products/development/debenu-pdf-viewer-sdk/

	Update History:
	===================================================
	2014/09/29
	v0.1 First oficial version

	===================================================
	2015/04/28
	v0.2
		added event Handling
		added _DPVS_StartUp()
		added _DPVS_Shutdown()
		modified _DPVS_ObjCreate()
		added _DPVS_ObjDestroy()
		added _DPVS_OnExit()
		Renamed _Viewer_Adlib() >> _DPVS_Viewer_Adlib()
		Renamed _DPSV__GUI() >> _DPVS__GUI()
		modified _DPVS__GUI()
		Renamed _DPSV__GUI_ChangeTitle() >> _DPVS__GUI_ChangeTitle()
		added _DPVS_CtrlObjDelete()
		added _DPVS_GUI_Destroy()
		added _DPVS_Hide()
		added _DPVS_Show()
		added _DPVS_SetBackgroundColor_RGB()
		added _DPVS_ButtonClose()


	2015/05/18
	v0.3
		added Function Header
		added _DPVS_Button_End()
		added _DPVS__GUI_FileName()
		modified _DPVS__GUI_ChangeTitle()
		modified error checking to _DPVS_OpenFile()
		added _DPVS_CloseFile()
		added _DPVS_OpenedFile()
		modified _DPVS_SaveToFile()
		added _DPVS_EventConsoleNotification()
		modified all functions _DPVS_EVENT_..... - now using _DPVS_EventConsoleNotification()
		added $g__fn_DPVS_EVENT_.....
		modified all functions _DPVS_EVENT_..... - now using $g__fn_DPVS_EVENT_.....
		Rename all functions _DPVS_Button..... >> _DPVS_Button_.....

#ce

#EndRegion QuickPDF.au3 - Header

#Region DPViewer.au3 - Global #VARIABLES#
Global $g__hDll_DPVS = 0

Global $g__fn_DPVS_EVENT_hScrollbarChanged
Global $g__fn_DPVS_EVENT_vScrollbarChanged
Global $g__fn_DPVS_EVENT_FocusGained
Global $g__fn_DPVS_EVENT_FocusLost
Global $g__fn_DPVS_EVENT_pageChanged
Global $g__fn_DPVS_EVENT_pageCountChanged
Global $g__fn_DPVS_EVENT_pageMouseDown
Global $g__fn_DPVS_EVENT_pageMouseUp
Global $g__fn_DPVS_EVENT_pageMouseMove
Global $g__fn_DPVS_EVENT_pageMouseDblClick
Global $g__fn_DPVS_EVENT_zoomChanged

_DPVS_EventConsoleNotification(False)

#EndRegion

#Region DPViewer.au3 - INIT


; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_EventConsoleNotification
; Description ...: Set or Get EventConsoleNotification status
; Syntax ........: _DPVS_EventConsoleNotification([$vValue = Default])
; Parameters ....: $vValue              - [optional] a variant value. Default is Default.
; Return values .: $bEventConsoleNotification
; Author ........: mLipok
; Modified ......:
; Remarks .......: If you pass Default as a parameter then function return actual state.
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _DPVS_EventConsoleNotification($vValue = Default)
	Local Static $bEventConsoleNotification = False

	If $vValue = Default Then
		Return $bEventConsoleNotification
	ElseIf $vValue = True Then
		$bEventConsoleNotification = True
		Return $bEventConsoleNotification
	Else
		$bEventConsoleNotification = False
		Return $bEventConsoleNotification
	EndIf

EndFunc

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_LicenseKey
; Description ...: Set license key to the DPVS object
; Syntax ........: _DPVS_LicenseKey(Byref $oDPVS, $sLicenseKey)
; Parameters ....: $oDPVS               - [in/out] an object.
;                  $sLicenseKey         - a string value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_LicenseKey(ByRef $oDPVS, $sLicenseKey)
	$oDPVS.LicenseKey = $sLicenseKey
EndFunc   ;==>_DPVS_LicenseKey

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_Shutdown
; Description ...: Close DLL / OCX
; Syntax ........: _DPVS_Shutdown()
; Parameters ....:
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_Shutdown()
	_DPVS_StartUp('DllClose')
EndFunc   ;==>_DPVS_Shutdown

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_StartUp
; Description ...: Open DLL / OCX
; Syntax ........: _DPVS_StartUp([$sParam = Default])
; Parameters ....: $sParam              - [optional] a string value. Default is Default.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: OCX and DLL should be placed in @scriptdir directory
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_StartUp($sParam = Default)
	Local Static $g__hDll_DPVS = Default
	If $sParam = Default Or $sParam <> 'DllClose' Then
		If $g__hDll_DPVS = Default Then
			Local $sDLLFile
			$sDLLFile = @ScriptDir & '\DebenuPDFViewerCtrl1114.ocx'

			If FileExists($sDLLFile) Then
				$g__hDll_DPVS = DllOpen($sDLLFile)
				If $g__hDll_DPVS = -1 Then
					MsgBox($MB_SYSTEMMODAL + $MB_OK + $MB_ICONERROR, "DllOpen Error", "Can not open: " & @CRLF & $sDLLFile)
					Return -1
				Else
					Return $g__hDll_DPVS
				EndIf
			Else
				MsgBox($MB_SYSTEMMODAL + $MB_OK + $MB_ICONERROR, "DllOpen Error", "Dll file does not exist: " & @CRLF & $sDLLFile)
				Return 0
			EndIf
		EndIf
	Else
		If $sParam = 'DllClose' Then
			DllClose($g__hDll_DPVS)
			$g__hDll_DPVS = ''
		EndIf

	EndIf
	Return $g__hDll_DPVS
EndFunc   ;==>_DPVS_StartUp


; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_ObjDestroy
; Description ...: Destroy current DPVS object
; Syntax ........: _DPVS_ObjDestroy()
; Parameters ....:
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_ObjDestroy()
	Return _DPVS_ObjCreate('')
EndFunc

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_ObjCreate
; Description ...: Create DPVS object
; Syntax ........: _DPVS_ObjCreate([$sParam = Default])
; Parameters ....: $sParam              - [optional] a string value. Default is Default.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_ObjCreate($sParam = Default)
	; Create ActivX object
	Local Static $oDPVS = Default
	If $sParam = Default And $oDPVS <> Default Then
		Return $oDPVS
	EndIf

	If $sParam = '' Then
		$oDPVS = ''
		Return $oDPVS
	Else
		If $oDPVS = Default Then

			#CS
				; Viewer v11.13
				Local $sCLSID_Commercial = '{3AC8E67E-7080-47A0-83DD-66A57CED12E9}'
				Local $sIID_Commercial = '{05408D9A-4941-4F70-8281-10145A483964}'
				$oDPVS = ObjCreate($sCLSID_Commercial, $sIID_Commercial, _DPVS_StartUp())
				$oDPVS.LibraryPath = @ScriptDir & '\DebenuPDFLibraryDLL1113.dll'
				$oDPVS.RendererPath = @ScriptDir & '\DebenuPDFRendererDLL1113.dll'

			#CE

			; Viewer v11.14
			Local $sCLSID_Commercial = '{3AC8E67E-7080-47A0-83DD-66A57CED12E9}'
			Local $sIID_Commercial = '{05408D9A-4941-4F70-8281-10145A483964}'
			$oDPVS = ObjCreate($sCLSID_Commercial, $sIID_Commercial, _DPVS_StartUp())
			$oDPVS.LibraryPath = @ScriptDir & '\DebenuPDFLibraryDLL1114.dll'
			$oDPVS.RendererPath = @ScriptDir & '\DebenuPDFRendererDLL1114.dll'

;~ 			MsgBox(0, '', 1)
;~ 			$oDPVS.DQPLSetGDIPlusOptions(3, 1) ; Turn on image smoothing
;~ 			MsgBox(0, '', 2)
		EndIf
		Return $oDPVS
	EndIf
EndFunc   ;==>_DPVS_ObjCreate

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_OnExit
; Description ...: Register function to CleanUp on program Exits
; Syntax ........: _DPVS_OnExit()
; Parameters ....:
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_OnExit()
	OnAutoItExitRegister('_DPVS_GUI_Destroy')
EndFunc   ;==>_DPVS_OnExit

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_Viewer_Adlib
; Description ...: TODO
; Syntax ........: _DPVS_Viewer_Adlib()
; Parameters ....:
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_Viewer_Adlib()
	Return
	Local $hWnd = _DPVS__GUI()
	Local Static $iGUI_PDFWidth = WinGetPos($hWnd)[2] - 20
	Local Static $iGUI_PDFHeight = WinGetPos($hWnd)[3] - 40
	Local $bMakeRefresh = False
	If $iGUI_PDFWidth <> WinGetPos($hWnd)[2] - 20 Then $bMakeRefresh = True
	If $iGUI_PDFHeight <> WinGetPos($hWnd)[3] - 40 Then $bMakeRefresh = True

	If $bMakeRefresh Then
		$iGUI_PDFWidth = WinGetPos($hWnd)[2] - 20
		$iGUI_PDFHeight = WinGetPos($hWnd)[3] - 40
		Local $obj = _DPVS_ObjCreate()
		Local $AXControl = _DPVS_CtrlObjCreate($obj)
		GUICtrlSetPos($AXControl, 5, 5, $iGUI_PDFWidth, $iGUI_PDFHeight)
;~ 		MsgBox(0, '', 'move')
	EndIf

EndFunc   ;==>_DPVS_Viewer_Adlib

#EndRegion DPViewer.au3 - INIT

#Region DPViewer.au3 - GUI

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS__GUI_ChangeTitle
; Description ...: Change title in Viewer GUI
; Syntax ........: _DPVS__GUI_ChangeTitle($sNewTitle)
; Parameters ....:
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS__GUI_ChangeTitle()
	WinSetTitle(_DPVS__GUI(), '', _
	'[ ' & _
	_DPVS_ObjCreate().GetCurrentPage()	& _
	' / ' &  _
	_DPVS_ObjCreate().DQPLPageCount() & _
	' ] ' & _
	_DPVS__GUI_FileName(_DPVS_OpenedFile()))
EndFunc   ;==>_DPVS__GUI_ChangeTitle

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS__GUI_FileName
; Description ...: Return file name
; Syntax ........: _DPVS__GUI_FileName()
; Parameters ....: $sPDF_FileFullPath   - a string value.
; Return values .: FileName or empty string
; Author ........: mLipok
; Modified ......:
; Remarks .......: this function is used only to _DPVS__GUI_ChangeTitle
; Related .......: _DPVS__GUI_ChangeTitle
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _DPVS__GUI_FileName($sPDF_FileFullPath)
	Local $aFileName = StringRegExp($sPDF_FileFullPath, '(?i).+\\(.*\.pdf)', 3)
	If UBound($aFileName) Then
		Return $aFileName[0]
	Else
		Return ''
	EndIf
EndFunc

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS__GUI
; Description ...: Make a standard GUI for Viewer
; Syntax ........: _DPVS__GUI([$sTitle = "DPVS PDF Viewer"[, $iLeft = Default[, $iTop = Default[, $iWidth = Default[,
;                  $iHeight = Default[, $hParrent = Default]]]]]])
; Parameters ....: $sTitle              - [optional] a string value. Default is "DPVS PDF Viewer".
;                  $iLeft               - [optional] an integer value. Default is Default.
;                  $iTop                - [optional] an integer value. Default is Default.
;                  $iWidth              - [optional] an integer value. Default is Default.
;                  $iHeight             - [optional] an integer value. Default is Default.
;                  $hParrent            - [optional] a handle value. Default is Default.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS__GUI($sTitle = "DPVS PDF Viewer", $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default, $hParrent = Default)
	Local Static $hWnd = Default
	If $sTitle = 'GUIDelete' And IsHWnd($hWnd) = 1 Then
		GUIDelete($hWnd)
	EndIf
	If $hWnd = Default Or IsHWnd($hWnd) = 0 Then
		$hWnd = GUICreate( _
				$sTitle, _
				$iWidth, $iHeight, $iLeft, $iTop, _
				 - 1, -1, _
				$hParrent _
				)
	EndIf
	Return $hWnd
EndFunc   ;==>_DPVS__GUI

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_CtrlObjCreate
; Description ...: Create Control related to DPVS Object
; Syntax ........: _DPVS_CtrlObjCreate(Byref $oDPVS[, $iLeft = Default[, $iTop = Default[, $iWidth = Default[, $iHeight = Default]]]])
; Parameters ....: $oDPVS               - [in/out] an object.
;                  $iLeft               - [optional] an integer value. Default is Default.
;                  $iTop                - [optional] an integer value. Default is Default.
;                  $iWidth              - [optional] an integer value. Default is Default.
;                  $iHeight             - [optional] an integer value. Default is Default.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: this function use GUISwitch(_DPVS__GUI())
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_CtrlObjCreate(ByRef $oDPVS, $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default)
	Local Static $idAXControl = Default
	If _
			(Not $idAXControl = Default) _
			And (Not IsObj($oDPVS)) _
			Then
		GUICtrlDelete($idAXControl)
		$idAXControl = Default
	EndIf

	If $iLeft = Default And $iTop = Default And $iWidth = Default And $iHeight = Default Then
		$iLeft = 1
		$iTop = 1
		$iWidth = WinGetPos(_DPVS__GUI())[2] - 12
		$iHeight = WinGetPos(_DPVS__GUI())[3] - 65
	EndIf
	If $idAXControl = Default Then
		GUISwitch(_DPVS__GUI())
		$idAXControl = GUICtrlCreateObj($oDPVS, $iLeft, $iTop, $iWidth, $iHeight)
	EndIf
	Return $idAXControl
EndFunc   ;==>_DPVS_CtrlObjCreate

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_CtrlObjDelete
; Description ...: Deletes a DPVS Viewer control.
; Syntax ........: _DPVS_CtrlObjDelete()
; Parameters ....:
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_CtrlObjDelete()
	Local $oDPVS = ''
	_DPVS_CtrlObjCreate($oDPVS)
EndFunc   ;==>_DPVS_CtrlObjDelete

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_GUI_Destroy
; Description ...: Function for OnAutoItExitRegister
; Syntax ........: _DPVS_GUI_Destroy()
; Parameters ....:
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: this function CleanUp all DPViewer.au3 elements: Object, Control and GUI, OCX/DLL
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_GUI_Destroy()
	_DPVS_CtrlObjDelete()
	_DPVS_ObjDestroy()
	_DPVS__GUI('GUIDelete')
	_DPVS_Shutdown()
EndFunc   ;==>_DPVS_GUI_Destroy

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_Hide
; Description ...: Hide entire DPVS Gui
; Syntax ........: _DPVS_Hide()
; Parameters ....:
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_Hide()
	WinSetState(_DPVS__GUI(), '', @SW_HIDE)
EndFunc   ;==>_DPVS_Hide

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_SetBackgroundColor_RGB
; Description ...: Set background color int DPVS Viewer object
; Syntax ........: _DPVS_SetBackgroundColor_RGB(Byref $oDPVS[, $dRedComponentColor = 0x80[, $dGreenComponentColor = 0x90[,
;                  $dBlueComponentColor = 0xff]]])
; Parameters ....: $oDPVS               - [in/out] an object.
;                  $dRedComponentColor  - [optional] a binary variant value. Default is 0x80.
;                  $dGreenComponentColor- [optional] a binary variant value. Default is 0x90.
;                  $dBlueComponentColor - [optional] a binary variant value. Default is 0xff.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_SetBackgroundColor_RGB(ByRef $oDPVS, $dRedComponentColor = 0x80, $dGreenComponentColor = 0x90, $dBlueComponentColor = 0xff)
	Local $aColor[3] = [$dRedComponentColor, $dGreenComponentColor, $dBlueComponentColor]
	$oDPVS.BackgroundColor = _ColorSetCOLORREF($aColor)
;~ 		$oDPVS.Refresh()
EndFunc   ;==>_DPVS_SetBackgroundColor_RGB

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_Show
; Description ...: Show entire DPVS Gui
; Syntax ........: _DPVS_Show()
; Parameters ....:
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_Show()
	WinSetState(_DPVS__GUI(), '', @SW_SHOW)
EndFunc   ;==>_DPVS_Show

#EndRegion DPViewer.au3 - GUI

#Region DPViewer.au3 - GUI - Buttons

Func _DPVS_Button_Back($sText = 'Back', $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default)
	If $iTop = Default Then $iTop = WinGetPos(_DPVS__GUI())[3] - $iHeight - 30
	Local Static $idButton_Back = Default
	If $idButton_Back = Default Then
		GUISwitch(_DPVS__GUI())
		$idButton_Back = GUICtrlCreateButton($sText, $iLeft, $iTop, $iWidth, $iHeight)
	EndIf
	Return $idButton_Back
EndFunc   ;==>_DPVS_Button_Back

Func _DPVS_Button_Close($sText = 'Close', $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default)
	If $iTop = Default Then $iTop = WinGetPos(_DPVS__GUI())[3] - $iHeight - 30
	Local Static $idButton_Close = Default
	If $idButton_Close = Default Then
		GUISwitch(_DPVS__GUI())
		$idButton_Close = GUICtrlCreateButton($sText, $iLeft, $iTop, $iWidth, $iHeight)
	EndIf
	Return $idButton_Close
EndFunc   ;==>_DPVS_Button_Close

Func _DPVS_Button_Forward($sText = 'Forward', $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default)
	If $iTop = Default Then $iTop = WinGetPos(_DPVS__GUI())[3] - $iHeight - 30
	Local Static $idButton_Forward = Default
	If $idButton_Forward = Default Then
		GUISwitch(_DPVS__GUI())
		$idButton_Forward = GUICtrlCreateButton($sText, $iLeft, $iTop, $iWidth, $iHeight)
	EndIf
	Return $idButton_Forward
EndFunc   ;==>_DPVS_Button_Forward

Func _DPVS_Button_Home($sText = 'Home', $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default)
	If $iTop = Default Then $iTop = WinGetPos(_DPVS__GUI())[3] - $iHeight - 30
	Local Static $idButton_Home = Default
	If $idButton_Home = Default Then
		GUISwitch(_DPVS__GUI())
		$idButton_Home = GUICtrlCreateButton($sText, $iLeft, $iTop, $iWidth, $iHeight)
	EndIf
	Return $idButton_Home
EndFunc   ;==>_DPVS_Button_Home

Func _DPVS_Button_End($sText = 'End', $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default)
	If $iTop = Default Then $iTop = WinGetPos(_DPVS__GUI())[3] - $iHeight - 30
	Local Static $idButton_Home = Default
	If $idButton_Home = Default Then
		GUISwitch(_DPVS__GUI())
		$idButton_Home = GUICtrlCreateButton($sText, $iLeft, $iTop, $iWidth, $iHeight)
	EndIf
	Return $idButton_Home
EndFunc   ;==>_DPVS_Button_Home

Func _DPVS_Button_Open($sText = 'Open', $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default)
	If $iTop = Default Then $iTop = WinGetPos(_DPVS__GUI())[3] - $iHeight - 30
	Local Static $idButton_Open = Default
	If $idButton_Open = Default Then
		GUISwitch(_DPVS__GUI())
		$idButton_Open = GUICtrlCreateButton($sText, $iLeft, $iTop, $iWidth, $iHeight)
	EndIf
	Return $idButton_Open
EndFunc   ;==>_DPVS_Button_Open

Func _DPVS_Button_Save($sText = 'Save', $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default)
	If $iTop = Default Then $iTop = WinGetPos(_DPVS__GUI())[3] - $iHeight - 30
	Local Static $idButton_Save = Default
	If $idButton_Save = Default Then
		GUISwitch(_DPVS__GUI())
		$idButton_Save = GUICtrlCreateButton($sText, $iLeft, $iTop, $iWidth, $iHeight)
	EndIf
	Return $idButton_Save
EndFunc   ;==>_DPVS_Button_Save

#EndRegion DPViewer.au3 - GUI - Buttons

#Region DPViewer.au3 - File Operations

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_OpenFile
; Description ...: Open PDF file in a DPVS Viewer Object
; Syntax ........: _DPVS_OpenFile(Byref $oDPVS, $sPDF_FileFullPath)
; Parameters ....: $oDPVS               - [in/out] an object.
;                  $sPDF_FileFullPath   - a string value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_OpenFile(ByRef $oDPVS, $sPDF_FileFullPath)
	GUISetState(@SW_LOCK, _DPVS__GUI())
	Local $bOpenStatus = $oDPVS.OpenFile($sPDF_FileFullPath)
	If $bOpenStatus Then
		_DPVS_OpenedFile($sPDF_FileFullPath )
		$oDPVS.ZoomFitWidth()
		$oDPVS.GotoFirstPage()
	EndIf
	GUISetState(@SW_UNLOCK, _DPVS__GUI())
EndFunc   ;==>_DPVS_OpenFile

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_CloseFile
; Description ...: Close PDF document, previously opened in a DPVS Viewer Object
; Syntax ........: _DPVS_CloseFile(Byref $oDPVS, $sPDF_FileFullPath)
; Parameters ....: $oDPVS               - [in/out] an object.
;                  $sPDF_FileFullPath   - a string value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _DPVS_CloseFile(ByRef $oDPVS)
	$oDPVS.CloseFile()
	_DPVS_OpenedFile('')
	$oDPVS.RefreshDocument()

EndFunc   ;==>_DPVS_OpenFile

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_OpenedFile
; Description ...: Function to store information about currently opened File
; Syntax ........: _DPVS_OpenedFile([$sPDF_FileFullPath = Default])
; Parameters ....: $sPDF_FileFullPath   - [optional] a string value. Default is Default.
; Return values .: Currently opened File
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_OpenedFile($sPDF_FileFullPath = Default)
	Local Static $sRet = ''
	If $sPDF_FileFullPath = Default Then
		Return $sRet
	Else
		If FileExists($sPDF_FileFullPath) Then
			$sRet = $sPDF_FileFullPath
			Return $sRet
		Else
			$sRet = ''
			Return SetError(1,0,$sRet)
		EndIf
	EndIf
EndFunc   ;==>_DPVS_OpenFile

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_SaveToFile
; Description ...: Save opened document to File.
; Syntax ........: _DPVS_SaveToFile(Byref $oDPVS[, $sPDF_FileFullPath = Default])
; Parameters ....: $oDPVS               - [in/out] an object.
;                  $sPDF_FileFullPath   - [optional] a string value. Default is Default.
; Return values .: $sPDF_FileFullPath or set @error see remarks
; Author ........: mLipok
; Modified ......:
; Remarks .......: for @error codes look in Au3 HelpFile for FileSaveDialog
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_SaveToFile(ByRef $oDPVS, $sPDF_FileFullPath = Default)
	If $sPDF_FileFullPath = Default Or $sPDF_FileFullPath = '' Then
		$sPDF_FileFullPath = FileSaveDialog('Save PDF File', @ScriptDir, 'PDF File (*.pdf)', $FD_PATHMUSTEXIST, '', _DPVS__GUI())
		If @error Then Return SetError(@error)
	EndIf
	If StringRight($sPDF_FileFullPath, 4) <> '.pdf' Then
		$sPDF_FileFullPath &= '.pdf'
	EndIf
	$oDPVS.DQPLCompressContent()
	$oDPVS.DQPLSaveToFile($sPDF_FileFullPath)
	Return $sPDF_FileFullPath
EndFunc   ;==>_DPVS_SaveToFile
#EndRegion DPViewer.au3 - File Operations

#Region DPViewer.au3 -_DPVS_EVENT

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_EVENT_hScrollbarChanged
; Description ...: Function to event management: hScrollbarChanged
; Syntax ........: _DPVS_EVENT_hScrollbarChanged($vMax, $vValue)
; Parameters ....: $vMax                - a variant value.
;                  $vValue              - a variant value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: to use this function you need to set $g__fn_DPVS_EVENT_hScrollbarChanged
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_EVENT_hScrollbarChanged($vMax, $vValue)
	if _DPVS_EventConsoleNotification() then
		ConsoleWrite('Event "hScrollbarChanged" was fired : $vMax = ' & $vMax & ' $vValue = ' & $vValue & @CR)
	EndIf
	If IsFunc($g__fn_DPVS_EVENT_hScrollbarChanged) Then Call($g__fn_DPVS_EVENT_hScrollbarChanged,$vMax,$vValue)
EndFunc   ;==>_DPVS_EVENT_hScrollbarChanged

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_EVENT_vScrollbarChanged
; Description ...: Function to event management: vScrollbarChanged
; Syntax ........: _DPVS_EVENT_vScrollbarChanged($vMax, $vValue)
; Parameters ....: $vMax                - a variant value.
;                  $vValue              - a variant value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: to use this function you need to set $g__fn_DPVS_EVENT_vScrollbarChanged
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_EVENT_vScrollbarChanged($vMax, $vValue)
	if _DPVS_EventConsoleNotification() then
		ConsoleWrite('Event "vScrollbarChanged" was fired : $vMax = ' & $vMax & ' $vValue = ' & $vValue & @CR)
	EndIf
	If IsFunc($g__fn_DPVS_EVENT_vScrollbarChanged) Then Call($g__fn_DPVS_EVENT_vScrollbarChanged,$vMax,$vValue)
EndFunc   ;==>_DPVS_EVENT_vScrollbarChanged

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_EVENT_FocusGained
; Description ...: Function to event management: FocusGained
; Syntax ........: _DPVS_EVENT_FocusGained($hWnd_Old)
; Parameters ....: $hWnd_Old            - a handle value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: to use this function you need to set $g__fn_DPVS_EVENT_FocusGained
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_EVENT_FocusGained($hWnd_Old)
	if _DPVS_EventConsoleNotification() then
		ConsoleWrite('Event "FocusGained" was fired : $hWnd_Old = ' & $hWnd_Old & @CR)
	EndIf
	If IsFunc($g__fn_DPVS_EVENT_FocusGained) Then Call($g__fn_DPVS_EVENT_FocusGained,$hWnd_Old)
EndFunc   ;==>_DPVS_EVENT_FocusGained

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_EVENT_FocusLost
; Description ...: Function to event management: FocusLost
; Syntax ........: _DPVS_EVENT_FocusLost($hWnd_New)
; Parameters ....: $hWnd_New            - a handle value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: to use this function you need to set $g__fn_DPVS_EVENT_FocusLost
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_EVENT_FocusLost($hWnd_New)
	if _DPVS_EventConsoleNotification() then
		ConsoleWrite('Event "FocusLost" was fired : $hWnd_New = ' & $hWnd_New & @CR)
	EndIf
	If IsFunc($g__fn_DPVS_EVENT_FocusLost) Then Call($g__fn_DPVS_EVENT_FocusLost,$hWnd_New)
EndFunc   ;==>_DPVS_EVENT_FocusLost

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_EVENT_pageChanged
; Description ...: Function to event management: pageChanged
; Syntax ........: _DPVS_EVENT_pageChanged($iCurrentPage)
; Parameters ....: $iCurrentPage        - an integer value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: to use this function you need to set $g__fn_DPVS_EVENT_pageChanged
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_EVENT_pageChanged($iCurrentPage)
	if _DPVS_EventConsoleNotification() then
		ConsoleWrite('Event "pageChanged" was fired : $iCurrentPage = ' & $iCurrentPage & @CR)
	EndIf
	If IsFunc($g__fn_DPVS_EVENT_pageChanged) Then Call($g__fn_DPVS_EVENT_pageChanged,$iCurrentPage)
EndFunc   ;==>_DPVS_EVENT_pageChanged

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_EVENT_pageCountChanged
; Description ...: Function to event management: pageCountChanged
; Syntax ........: _DPVS_EVENT_pageCountChanged($iPageCount)
; Parameters ....: $iPageCount          - an integer value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: to use this function you need to set $g__fn_DPVS_EVENT_pageCountChanged
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_EVENT_pageCountChanged($iPageCount)
	if _DPVS_EventConsoleNotification() then
		ConsoleWrite('Event "pageCountChanged" was fired : $iPageCount = ' & $iPageCount & @CR)
	EndIf
	If IsFunc($g__fn_DPVS_EVENT_pageCountChanged) Then Call($g__fn_DPVS_EVENT_pageCountChanged,$iPageCount)
EndFunc   ;==>_DPVS_EVENT_pageCountChanged

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_EVENT_pageMouseDown
; Description ...: Function to event management: pageMouseDown
; Syntax ........: _DPVS_EVENT_pageMouseDown($iPageNumber, $iXPos, $iYPos)
; Parameters ....: $iPageNumber         - an integer value.
;                  $iXPos               - an integer value.
;                  $iYPos               - an integer value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: to use this function you need to set $g__fn_DPVS_EVENT_pageMouseDown
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_EVENT_pageMouseDown($iPageNumber, $iXPos, $iYPos)
	if _DPVS_EventConsoleNotification() then
		ConsoleWrite('Event "pageMouseDown" was fired : $iPageNumber = ' & $iPageNumber & ' $iXPos = ' & $iXPos & '  $iYPos = ' & $iYPos & @CR )
	EndIf
	If IsFunc($g__fn_DPVS_EVENT_pageMouseDown) Then Call($g__fn_DPVS_EVENT_pageMouseDown,$iPageNumber,$iXPos,$iYPos)
EndFunc   ;==>_DPVS_EVENT_pageMouseDown

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_EVENT_pageMouseUp
; Description ...: Function to event management: pageMouseUp
; Syntax ........: _DPVS_EVENT_pageMouseUp($iPageNumber, $iXPos, $iYPos)
; Parameters ....: $iPageNumber         - an integer value.
;                  $iXPos               - an integer value.
;                  $iYPos               - an integer value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: to use this function you need to set $g__fn_DPVS_EVENT_pageMouseUp
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_EVENT_pageMouseUp($iPageNumber, $iXPos, $iYPos)
	if _DPVS_EventConsoleNotification() then
		ConsoleWrite('Event "pageMouseUp" was fired : $iPageNumber = ' & $iPageNumber & ' $iXPos = ' & $iXPos & '  $iYPos = ' & $iYPos & @CR )
	EndIf
	If IsFunc($g__fn_DPVS_EVENT_pageMouseUp) Then Call($g__fn_DPVS_EVENT_pageMouseUp,$iPageNumber,$iXPos,$iYPos)
EndFunc   ;==>_DPVS_EVENT_pageMouseUp

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_EVENT_pageMouseMove
; Description ...: Function to event management: pageMouseMove
; Syntax ........: _DPVS_EVENT_pageMouseMove($iPageNumber, $iXPos, $iYPos)
; Parameters ....: $iPageNumber         - an integer value.
;                  $iXPos               - an integer value.
;                  $iYPos               - an integer value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: to use this function you need to set $g__fn_DPVS_EVENT_pageMouseMove
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_EVENT_pageMouseMove($iPageNumber, $iXPos, $iYPos)
	if _DPVS_EventConsoleNotification() then
		ConsoleWrite('Event "pageMouseMove" was fired : $iPageNumber = ' & $iPageNumber & ' $iXPos = ' & $iXPos & '  $iYPos = ' & $iYPos & @CR )
	EndIf
	If IsFunc($g__fn_DPVS_EVENT_pageMouseMove) Then Call($g__fn_DPVS_EVENT_pageMouseMove,$iPageNumber,$iXPos,$iYPos)
EndFunc   ;==>_DPVS_EVENT_pageMouseMove

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_EVENT_pageMouseDblClick
; Description ...: Function to event management: pageMouseDblClick
; Syntax ........: _DPVS_EVENT_pageMouseDblClick($iPageNumber, $iXPos, $iYPos)
; Parameters ....: $iPageNumber         - an integer value.
;                  $iXPos               - an integer value.
;                  $iYPos               - an integer value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: to use this function you need to set $g__fn_DPVS_EVENT_pageMouseDblClick
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_EVENT_pageMouseDblClick($iPageNumber, $iXPos, $iYPos)
	if _DPVS_EventConsoleNotification() then
		ConsoleWrite('Event "pageMouseDblClick" was fired : $iPageNumber = ' & $iPageNumber & ' $iXPos = ' & $iXPos & '  $iYPos = ' & $iYPos & @CR )
	EndIf
	If IsFunc($g__fn_DPVS_EVENT_pageMouseDblClick) Then Call($g__fn_DPVS_EVENT_pageMouseDblClick,$iPageNumber, $iXPos, $iYPos)
EndFunc   ;==>_DPVS_EVENT_pageMouseDblClick

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_EVENT_zoomChanged
; Description ...: Function to event management: zoomChanged
; Syntax ........: _DPVS_EVENT_zoomChanged($vZoom)
; Parameters ....: $vZoom               - a variant value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: to use this function you need to set $g__fn_DPVS_EVENT_zoomChanged
; Related .......:
; Link ..........:
; Example .......: DPViewer_Example.au3
; ===============================================================================================================================
Func _DPVS_EVENT_zoomChanged($vZoom)
	if _DPVS_EventConsoleNotification() then
		ConsoleWrite('Event "zoomChanged" was fired : $vZoom = ' & $vZoom & @CR)
	EndIf
	If IsFunc($g__fn_DPVS_EVENT_zoomChanged) Then Call($g__fn_DPVS_EVENT_zoomChanged,$vZoom)
EndFunc   ;==>_DPVS_EVENT_zoomChanged

#EndRegion DPViewer.au3 -_DPVS_EVENT

#Region DPViewer.au3 - Testing
; Parameters for SetMeasurementUnits

;~ _DPVS_StartUp()

#CS
	Global Enum _
	$__eQPDF_MUNITS_Default = 0, _
	$__eQPDF_MUNITS_Milimeters, _
	$__eQPDF_MUNITS_Inches

	; Parameters for SetOrigin
	Global Enum _
	$__eQPDF_SORIGIN_BottomLeft = 0, _
	$__eQPDF_SORIGIN_TopLeft, _
	$__eQPDF_SORIGIN_TopRight, _
	$__eQPDF_SORIGIN_BottomRight

#CE

#EndRegion
