#Tidy_Parameters=/sort_funcs /reel
;~ #AutoIt3Wrapper_Run_Debug_Mode=Y
#AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6 -w- 7
;~ #AutoIt3Wrapper_Au3Check_Parameters=-q -d -w 1 -w 2 -w 3 -w- 4 -w 5 -w 6 -w- 7
#include "DPViewer.au3"
#include "Color.au3"

#Region DPViewer_Example.au3 - EVENT Function assign
$g__fn_DPVS_EVENT_pageChanged = _fn_DPVS_EVENT_pageChanged

#EndRegion

#Region DPViewer_Example.au3 - Global Variable declaration
Global Enum _
		$g__eQPDF_MUNITS_Default = 0, _
		$g__eQPDF_MUNITS_Milimeters, _
		$g__eQPDF_MUNITS_Inches

; Parameters for SetOrigin
Global Enum _
		$g__eQPDF_SORIGIN_BottomLeft = 0, _
		$g__eQPDF_SORIGIN_TopLeft, _
		$g__eQPDF_SORIGIN_TopRight, _
		$g__eQPDF_SORIGIN_BottomRight

#EndRegion DPViewer_Example.au3 - Global Variable declaration

#Region DPViewer_Example.au3 - Main Loop

_DPVS_EventConsoleNotification(True)
_DPVS_StartUp()

_Example_MakeFullGui()

Func _Example_MakeFullGui()
	_DPVS__GUI('PDF', 100, 10, 800, 700)
;~ 	WinSetOnTop(_DPVS__GUI(), '', 1)
	GUISetState(@SW_SHOW)

	; collection of Standard UDF Button
	_DPVS_Button_Back("Back", 10, Default, 80, 30)
	_DPVS_Button_Forward("Forward", 100, Default, 80, 30)
	_DPVS_Button_Home("Home", 190, Default, 80, 30)
	_DPVS_Button_End("End", 190, Default, 80, 30)
	_DPVS_Button_Open("Open", 280, Default, 80, 30)
	_DPVS_Button_Save("Save", 370, Default, 80, 30)
	_DPVS_Button_Close("Close", 460, Default, 80, 30)

	; additional button - Not from UDF
	_DPVS_Button_Stamp("Stamp", 670, Default, 100, 30)

	; Show GUI
	GUISetState(@SW_SHOW,_DPVS__GUI())

	; create Debenu Viewer Object
	Local $oDPVS = _DPVS_ObjCreate()

	; ENTER YOUR License KEY HERE
	Local $sLicenseKey = ''
	; or just copy "c:\Program Files (x86)\Debenu\PDF Viewer SDK\TRIAL_LICENSE_KEY.TXT" to @ScriptDir & '\TRIAL_LICENSE_KEY.TXT'
	If FileExists(@ScriptDir & '\TRIAL_LICENSE_KEY.TXT') Then $sLicenseKey = FileRead(@ScriptDir & '\TRIAL_LICENSE_KEY.TXT')

	; I (mLipok) use MyLicenseKey.txt file to prevent accidentally placed my license key in a public forum.
	If FileExists(@ScriptDir & '\MyLicenseKey.txt') Then $sLicenseKey = FileRead(@ScriptDir & '\MyLicenseKey.txt')

	_DPVS_LicenseKey($oDPVS, $sLicenseKey)

	; error handling
	Local $oErrorHandler = ObjEvent("AutoIt.Error", "_DPVS_ErrFunc")
	#forceref $oErrorHandler
;~ 	$oErrorHandler = 0

	; event handling
	Local $oEventHandler = ObjEvent($oDPVS, '_DPVS_EVENT_')
	#forceref $oEventHandler
;~ 	MsgBox(0, '', VarGetType($oEventHandler ))
	$oEventHandler = 0


	Local $aColor[3] = [0x80, 0x90, 0xff]
	$oDPVS.BackgroundColor = _ColorSetCOLORREF($aColor)

;~ 	$oDPVS.DQPLSetGDIPlusOptions(3, 1)
;~ 	$oDPVS.DQPLSetGDIPlusOptions(3, 1)
;~ 	$oDPVS.DQPLSetGDIPlusOptions(10, 1)

	; some set up
;~ 	$oDPVS.ZoomFitWidth()
;~ 	$oDPVS.ToolbarEnabled = True

	_DPVS_CtrlObjCreate($oDPVS)


	; Loop until the user exits.
	Local $iMsg
	AdlibRegister(_DPVS_Viewer_Adlib())
	_DPVS_OnExit()

	Local $sPDF_FileFullPath = ''
	While 1
		$iMsg = GUIGetMsg()

		Select
			Case $iMsg = $GUI_EVENT_CLOSE
				ExitLoop

			Case $iMsg = _DPVS_Button_Back()
				$oDPVS.PrevPage()
				_DPVS__GUI_ChangeTitle()

			Case $iMsg = _DPVS_Button_Forward()
				$oDPVS.NextPage()
				_DPVS__GUI_ChangeTitle()

			Case $iMsg = _DPVS_Button_Home()
				$oDPVS.GotoFirstPage()
				_DPVS__GUI_ChangeTitle()

			Case $iMsg = _DPVS_Button_End()
				$oDPVS.GotoLastPage()
				_DPVS__GUI_ChangeTitle()

			Case $iMsg = _DPVS_Button_Open()
				$sPDF_FileFullPath = FileOpenDialog('Select PDF File', @ScriptDir, 'PDF File (*.pdf)')
				If @error Then
					; here your stuff
				Else
					_DPVS_OpenFile($oDPVS, $sPDF_FileFullPath)
					_DPVS__GUI_ChangeTitle()
				EndIf

			Case $iMsg = _DPVS_Button_Save()
				$sPDF_FileFullPath = _DPVS_SaveToFile($oDPVS)
				If @error Then
					; here your stuff
				Else
					_DPVS__GUI_ChangeTitle()
				EndIf

			Case $iMsg = _DPVS_Button_Close()
				_DPVS_CloseFile($oDPVS)
				_DPVS__GUI_ChangeTitle()

			Case $iMsg = _DPVS_Button_Stamp()
;~ 				_Make_a_STAMP($oDPVS, 20, 45, 'MY OFFICE' & @CRLF & 'My Name', '20-09-2014', '12:07', 1, 'my ID #')
				$oDPVS.DQPLSetOrigin($g__eQPDF_SORIGIN_TopLeft);
				$oDPVS.DQPLSetMeasurementUnits($g__eQPDF_MUNITS_Milimeters)
				$oDPVS.DQPLNormalizePage(0)
				_Make_a_STAMP($oDPVS, 20, 10, 'My Organization Name ' & @CRLF & 'My Name', '20-09-2014', '12:07', 1, 'my ID #')
				$oDPVS.ZoomOut()
				$oDPVS.ZoomIn()
		EndSelect

	WEnd
	$oDPVS = '' ; CleanUp

	GUIDelete()
EndFunc   ;==>_Example_MakeFullGui
#EndRegion DPViewer_Example.au3 - Main Loop

#Region DPViewer_Example.au3 - Functions

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_Button_Stamp
; Description ...: Additional Button to Add some stamp to the PDF
; Syntax ........: _DPVS_Button_Stamp([$sText = Default[, $iLeft = Default[, $iTop = Default[, $iWidth = Default[, $iHeight = Default]]]]])
; Parameters ....: $sText               - [optional] a string value. Default is Default.
;                  $iLeft               - [optional] an integer value. Default is Default.
;                  $iTop                - [optional] an integer value. Default is Default.
;                  $iWidth              - [optional] an integer value. Default is Default.
;                  $iHeight             - [optional] an integer value. Default is Default.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _DPVS_Button_Stamp($sText = Default, $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default)
	If $iTop = Default Then $iTop = WinGetPos(_DPVS__GUI())[3] - $iHeight - 30
	Local Static $idButton_Make_a_STAMP = Default
	If $idButton_Make_a_STAMP = Default Then
		GUISwitch(_DPVS__GUI())
		$idButton_Make_a_STAMP = GUICtrlCreateButton($sText, $iLeft, $iTop, $iWidth, $iHeight)
	EndIf
	Return $idButton_Make_a_STAMP
EndFunc   ;==>_DPVS_Button_Stamp

; #FUNCTION# ====================================================================================================================
; Name ..........: _Make_a_STAMP
; Description ...: make a stamp in an opened document
; Syntax ........: _Make_a_STAMP(Byref $oDPVS, $iLeft, $iTop, $sOrganizationName, $sDate, $sTime, $iNoOfAttachments, $sSignID)
; Parameters ....: $oDPVS               - [in/out] reference to the ActiveX object
;                  $iLeft               - An integer value.
;                  $iTop                - An integer value.
;                  $sOrganizationName   - A string value.
;                  $sDate               - A string value.
;                  $sTime               - A string value.
;                  $iNoOfAttachments    - An integer value.
;                  $sSignID             - A string value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: You should open document before you use this function
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _Make_a_STAMP(ByRef $oDPVS, $iLeft, $iTop, $sOrganizationName, $sDate, $sTime, $iNoOfAttachments, $sSignID)
	Local $iStampWidth = 75, $iStampHeight = 35
	$iLeft = Number($iLeft)
	$iTop = Number($iTop)
	$oDPVS.DQPLSetOrigin($g__eQPDF_SORIGIN_TopLeft);
	$oDPVS.DQPLSetMeasurementUnits($g__eQPDF_MUNITS_Milimeters)
	$oDPVS.DQPLSetTransparency(20)
	$oDPVS.DQPLSetLineWidth(1)
	$oDPVS.DQPLSetLineColor(1, 0, 0)
	$oDPVS.DQPLDrawBox($iLeft, $iTop, $iStampWidth, $iStampHeight, 0)
	Local $iIDFont = $oDPVS.DQPLAddTrueTypeFont('Arial {1250}', 0)
	$oDPVS.DQPLSelectFont($iIDFont)
	$oDPVS.DQPLSetTextSize(10)
	$oDPVS.DQPLSetTextAlign(1)
	$oDPVS.DQPLDrawWrappedText($iLeft + 2, $iTop + 5, $iStampWidth - 4, $sOrganizationName)
	$oDPVS.DQPLSetTextSize(11)
	$oDPVS.DQPLDrawWrappedText($iLeft + 2, $iTop + 25, $iStampWidth - 4, 'received: ' & $sDate & '  time: ' & $sTime)
	$oDPVS.DQPLDrawWrappedText($iLeft + 2, $iTop + 30, $iStampWidth - 4, '# of Attach.: ' & $iNoOfAttachments & '    Sign #: ' & $sSignID)
EndFunc   ;==>_Make_a_STAMP
#EndRegion DPViewer_Example.au3 - Functions


#Region DPViewer_Example.au3 - EVENTS

Func _fn_DPVS_EVENT_pageChanged($iCurrentPage)
	#forceref $iCurrentPage
	_DPVS__GUI_ChangeTitle()
EndFunc

; User's COM error function. Will be called if COM error occurs
Func _DPVS_ErrFunc($oError)
    ; Do anything here.
    ConsoleWrite(@ScriptName & " (" & $oError.scriptline & ") : ==> COM Error intercepted !" & @CRLF & _
            @TAB & "err.number is: " & @TAB & @TAB & "0x" & Hex($oError.number) & @CRLF & _
            @TAB & "err.windescription:" & @TAB & $oError.windescription & @CRLF & _
            @TAB & "err.description is: " & @TAB & $oError.description & @CRLF & _
            @TAB & "err.source is: " & @TAB & @TAB & $oError.source & @CRLF & _
            @TAB & "err.helpfile is: " & @TAB & $oError.helpfile & @CRLF & _
            @TAB & "err.helpcontext is: " & @TAB & $oError.helpcontext & @CRLF & _
            @TAB & "err.lastdllerror is: " & @TAB & $oError.lastdllerror & @CRLF & _
            @TAB & "err.scriptline is: " & @TAB & $oError.scriptline & @CRLF & _
            @TAB & "err.retcode is: " & @TAB & "0x" & Hex($oError.retcode) & @CRLF & @CRLF)
EndFunc   ;==>_ErrFunc

#EndRegion